/**
 * @file hl7800_common.h
 * @brief HL7800 Library setting <br>
 * 
 * @date  2019/9/5 Preview-Alpha
 * @author kt-nakamura@kddi-tech.com
 */

#ifndef COMMON_H
#define COMMON_H

#define MODEM_SHORT_TIMEOUT     2000 // 2sec
#define MODEM_LONG_TIMEOUT     10000 // 10sec
#define MODEM_CONNECT_TIMEOUT  30000 // 30sec
#define MODEM_DISCONNECT_TIMEOUT  40000 // 40sec

#if defined(__AVR__) // AVR leaf
 #define RCVBUFF_SIZE 100
 #define SNDBUFF_SIZE 100
 #define DBGSERIAL Serial
 #define DBGBPS 9600
 #define USE_SOFTSERIAL
 #define MDMRX 9
 #define MDMTX 8
 #define MDMRTS 11  // Hardware-flow
 #define MDMDTR 12  // Hardware-flow
 #define MDMCTS A3  // Hardware-flow
 #define MDMBPS 9600
#else // Arudino M0 leaf
 #define RCVBUFF_SIZE 2048
 #define SNDBUFF_SIZE 2048
 #define DBGSERIAL SerialUSB
 #define DBGBPS 9600
 #define USE_USBSERIAL
 #define USE_ALTSERIAL  // arduino D8(TXD) D9(RXD)にserail5を割り当てる
 #define MDMSERIAL Serial5
// #define MDMSERIAL Serial1
 #define MDMRX 9
 #define MDMTX 8
 #define MDMARX 0   // Non-ALT RXD
 #define MDMATX 1   // Non-ALT TXD
 #define MDMRTS 11  // Hardware-flow
 #define MDMDTR 12  // Hardware-flow
 #define MDMCTS A3  // Hardware-flow
 #define MDMBPS 9600
#endif

#define MDMRI 3
#define MDMDSR 13 // LED_BUILTINと衝突するため要回路切断
#define MDMPWRON 4
#define MDMRST 5
#define MDMWAKEUP 10

#endif // COMMON_H
