/**
 * @file hl7800_client.h
 * @brief HL7800 modem TCP client API <br>
 * 
 * @date  2019/9/5 Preview-Alpha
 * @author kt-nakamura@kddi-tech.com
 */

#ifndef HL7800_CLIENT_H
#define HL7800_CLIENT_H

#include "Arduino.h"
#include "common.h"
#include <Client.h>
#include "IPAddress.h"

class HL7800Client : public Client {

protected:
// uint8_t _sock;
  char cmd[20];
  int connection_id;
  bool tcp_connect;
  int recived_size;
  char* read_p;
  
public:
  HL7800Client();  // Constructor
  virtual int connect(IPAddress ip, uint16_t port);
  virtual int connect(const char *host, uint16_t port);
  virtual size_t write(uint8_t);
  virtual size_t write(const uint8_t *buf, size_t size);
  virtual int available();
  virtual int read();
  virtual int read(uint8_t *buf, size_t size);
  virtual int peek();
  virtual void flush();
  virtual void stop();
  virtual uint8_t connected();
  virtual operator bool();

};

#endif // HL7800_CLIENT_H
