/**
 * @file hl7800_http.h
 * @brief HL7800 modem HTTP client API <br>
 * 
 * @date  2019/9/5 Preview-Alpha
 * @author kt-nakamura@kddi-tech.com
 */

#ifndef HL7800_HTTP_H
#define HL7800_HTTP_H

#include "Arduino.h"
#include "common.h"
#include "IPAddress.h"

#define HTTP_PORT 80
#define HTTPS_PORT 81
#define USE_HTTP 0  // HTTP 1.1
#define USE_HTTPS 2 // HTTP 1.1 over TLS
#define USE_IPV4 0
#define USE_IPV6 1

class HL7800Http {
public:
  HL7800Http();  // Constructor
  int connect(IPAddress ip, uint16_t port, int http_version, char* login, char* passwd);
  int connect(char* url, uint16_t port, int http_version, char* login, char* passwd);
  int config(char* header);

  int get(char* uri, char* buff, bool show_resp);
  int head(char* uri, char* buff);
  int post(char* uri, char* buff, bool show_resp);
  int put(char* uri, char* sndbuff, char* rcvbuff, bool show_resp);

  bool connected();
  void close();
  
private:
  char cmd[70];
  bool http_connect;
};


#endif // HL7800_HTTP_H
