/**
 * @file hl7800_modem.h
 * @brief HL7800 modem control API <br>
 * 
 * @date  2019/9/5 Preview-Alpha
 * @author kt-nakamura@kddi-tech.com
 */

#ifndef HL7800_MODEM_H
#define HL7800_MODEM_H

#include "common.h"
#include "Arduino.h"
#include "IPAddress.h"

#define SLEEP_MODE 0
#define LIGHT_HIBERNATE 1
#define HIBERNATE 2

class HL7800Modem {
protected:
  bool activated;
  
public:
  HL7800Modem();  // Constructor
  bool Init();
  bool activatePdp(const char* accessPointName, const char* userName, const char* password, long waitForRegistTimeoutMs = 120000);
  bool deactivate(void);
  bool isActive();
  bool chkModem();
  bool waitModem(void);
 
  IPAddress getIpAddress(void);
  bool chkIpAddress(void);
  int getRssi(void);
  bool chkPin(void);
  int getImei(char* buff);
  int getCcid(char* buff);
  int getRTC(char* buff);

  bool setEDRX(int edrx_value);
  bool enterSleep(int mode);
  bool leaveSleep();
  bool powerDown(void);
  bool powerUp();
  
//  int setPSM(int mode,int Period);
//  int setEDRX(boolan enable,char value);

public:
//  enum SocketType { 
//    SOCKET_TCP, 
//    SOCKET_UDP, 
//  }; 

};

#endif // HL7800_MODEM_H
