/**
 * @file hl7800_serial.h
 * @brief HL7800 serial driver <br>
 * 
 * @date  2019/9/5 Preview-Alpha
 * @author kt-nakamura@kddi-tech.com
 */

#ifndef HL7800_SERIAL_H
#define HL7800_SERIAL_H

#include "Arduino.h"
#include "common.h"

class HL7800Serial
{
  private:
  public:
    void Init(void);
    void WriteCommand(char* command);
    void WriteData(const uint8_t* data, int length);
    char* ReadResponse(const char* patternOK, const char* patternNG, unsigned long timeout_ms);
    char* WriteCommandAndReadResponse(char* command, const char* patternOK, const char* patternNG, unsigned long timeout_ms);
};

#endif // HL7800_SERIAL_H
